import { SagaIterator } from 'redux-saga';
import { call, Effect, fork, put, takeEvery } from 'redux-saga/effects';

import Action from '@overflow/commons/redux/Action';
import * as AsyncRequestActions  from '@overflow/commons/redux/action/asyncRequest';

import WebSocketRPC from '@overflow/commons/websocket/WebSocketRPC';

import AsyncRequestPayload from '@overflow/commons/redux/payload/AsyncRequestPayload';
import SagaWatcher from '@overflow/commons/redux/saga/SagaWatcher';


export class AsyncRequest implements SagaWatcher {
  private webSocketRPC: WebSocketRPC;

  private * request(action: Action<AsyncRequestPayload>): SagaIterator {
    const {service, method, requestType, args} = action.payload;
    try {
      // yield put({
      //   type: types.SENDING_REQUEST,
      //   payload: {sendingRequest: true},
      // });`${service}.${method}`
      // let webSocketRPC: WebSocketRPC = GetAppContext().getPouchByClass(WebSocketRPC.prototype, undefined);
      let result = yield call({context: this.webSocketRPC, fn: this.webSocketRPC.Call}, `${service}.${method}`, args);

      // yield put(AsyncRequestActions.requestSuccess(requestType, result));
    } catch (e) {
      yield put(AsyncRequestActions.requestFailure(requestType, e));
    } finally {
      // yield put({
      //   type: types.SENDING_REQUEST,
      //   payload: {sendingRequest: false},
      // });
    }
  }

  public * watch(): SagaIterator {
    yield takeEvery(AsyncRequestActions.REQUEST, this.request);
  }

}

export default AsyncRequest;
